(*
	IV окружной этап Всероссийской олимпиады школьников по информатике
	24 - 28 марта 2006 г.
	г. Петрозаводск

	Задача A. Фигурное программирование
	Авторы: Р. Сошкин, А. Николаевский, В.А. Кузнецов
	Решение: А. Урбан
*)

{$apptype console}
{$O-,Q+,R+}
const
 fname='figure';
 fin=fname+'.in';
 fout=fname+'.out';
 MAXN=20;
 eps=5e-3;

var
 n, i, k, nbit, j : longint;
 sum, curs, min, max : extended;
 mas : array[1..MAXN] of extended;

begin
 reset(input, fin); rewrite(output, fout);

 read(n, k);
 for i := 1 to n do read(mas[i]);
 read(sum);

 for i := 0 to (1 shl n)-1 do
 begin
  nbit:=0;
  for j := 0 to n-1 do
   if ((i shr j) and 1=1) then inc(nbit);

  if (nbit<>k) then continue;

  curs:=0.0; min:=1e10; max:=-1e10;
  for j := 0 to n-1 do
   if ((i shr j) and 1=0) then
   begin
    curs:=curs+mas[j+1];
    if (min>mas[j+1]) then min:=mas[j+1];
    if (max<mas[j+1]) then max:=mas[j+1];
   end;

  curs:=curs-min-max;
  if (abs(sum-(curs/(n-k-2)))<eps) then
  begin
       write(min:0:2, ' ', max:0:2);
       for j := 0 to n-1 do
        if ((i shr j) and 1=1) then write(' ', mas[j+1]:0:2);
       exit;
  end;

 end;

end.